



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux lsof命令使用小结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux lsof命令使用小结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 17:36:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
</div>
<div>&nbsp;</div>
<div>
<div>&nbsp;</div>
<p>lsof(list open files)是一个列出当前系统打开文件的工具。在Linux环境下，任何事物都是以文件的形式存在，通过文件不仅可以访问常规数据，还可以访问网络连接和硬件。所以，如传输控制协议(TCP)和用户数据报协议(UDP)套接字等，系统在后台都为该应用程序分配了一个文件描述符，无论这个文件的本质如何，该文件描述符为应用程序与基础操作系统之间的交互提供了通用接口。因为应用程序打开文件的描述符列表提供了大量关于这个应用程序本身的信息，因此通过lsof工具能够查看这个列表对系统监测以及排错是很有帮助的。</p>
<p>图1：lsof示例</p>
<p>在终端下输入lsof即可显示系统打开的文件，因为lsof需要访问核心内存和各种文件，所以必须以root用户的身份运行它才能够充分地发挥功能。</p>
<p>如上图1是一个lsof的输出例子，每行显示一个打开的文件，若不指定默认显示所有进程打开的所有文件。</p>
<p>lsof输出各列信息的意义如下：</p>
<p>COMMAND：进程的名称</p>
<p>PID：进程标识符</p>
<p>USER：进程所有者</p>
<p>FD：文件描述符，应用程序通过文件描述符识别该文件，如cwd、txt等。</p>
<p>TYPE：文件类型，如：DIR、REG等。</p>
<p>DEVICE：指定磁盘的名称</p>
<p>SIZE：文件的大小</p>
<p>NODE：索引节点(文件在磁盘上的标识)</p>
<p>NAME：打开文件的确切名称</p>
<p>FD列中的文件描述符cwd值表示应用程序的当前工作目录，这是该应用程序启动的目录，除非它本身对这个目录进行更改，txt类型的文件是程序代码，如应用程序二进制文件本身或共享库。其次数值标识应用程序的文件描述符，这是打开该文件时返回的一个整数。与 FD 列相比，Type 列则比较直观。文件和目录分别称为REG和DIR。而CHR和BLK，分别表示字符和块设备；或者UNIX、FIFO和IPv4，分别表示UNIX域套接字、先进先出(FIFO)队列和网际协议(IP)套接字。</p>
<p>下面是一些实用的命令：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
<div>16</div>
<div>17</div>
<div>18</div>
</td>
<td>
<div>
<div><code>lsof</code>&nbsp;<code>`</code><code>which</code>&nbsp;<code>httpd`&nbsp;</code><code>//</code><code>那个进程在使用apache的可执行文件</code></div>
<div><code>lsof</code>&nbsp;<code>/etc/passwd</code>&nbsp;<code>//</code><code>那个进程在占用</code><code>/etc/passwd</code></div>
<div><code>lsof</code>&nbsp;<code>/dev/hda6</code>&nbsp;<code>//</code><code>那个进程在占用hda6</code></div>
<div><code>lsof</code>&nbsp;<code>/dev/cdrom</code>&nbsp;<code>//</code><code>那个进程在占用光驱</code></div>
<div><code>lsof</code>&nbsp;<code>-c sendmail&nbsp;</code><code>//</code><code>查看sendmail进程的文件使用情况</code></div>
<div><code>lsof</code>&nbsp;<code>-c courier -u ^zahn&nbsp;</code><code>//</code><code>显示出那些文件被以courier打头的进程打开，但是并不属于用户zahn</code></div>
<div><code>lsof</code>&nbsp;<code>-p 30297&nbsp;</code><code>//</code><code>显示那些文件被pid为30297的进程打开</code></div>
<div><code>lsof</code>&nbsp;<code>-D&nbsp;</code><code>/tmp</code>&nbsp;<code>显示所有在</code><code>/tmp</code><code>文件夹中打开的instance和文件的进程。但是symbol文件并不在列</code></div>
<div><code>&nbsp;</code>&nbsp;</div>
<div><code>lsof</code>&nbsp;<code>-u1000&nbsp;</code><code>//</code><code>查看uid是100的用户的进程的文件使用情况</code></div>
<div><code>lsof</code>&nbsp;<code>-utony&nbsp;</code><code>//</code><code>查看用户tony的进程的文件使用情况</code></div>
<div><code>lsof</code>&nbsp;<code>-u^tony&nbsp;</code><code>//</code><code>查看不是用户tony的进程的文件使用情况(^是取反的意思)</code></div>
<div><code>lsof</code>&nbsp;<code>-i&nbsp;</code><code>//</code><code>显示所有打开的端口</code></div>
<div><code>lsof</code>&nbsp;<code>-i:80&nbsp;</code><code>//</code><code>显示所有打开80端口的进程</code></div>
<div><code>lsof</code>&nbsp;<code>-i -U&nbsp;</code><code>//</code><code>显示所有打开的端口和UNIX domain文件</code></div>
<div><code>lsof</code>&nbsp;<code>-i UDP@[url]www.akadia.com:123&nbsp;</code><code>//</code><code>显示那些进程打开了到www.akadia.com的UDP的123(ntp)端口的链接</code></div>
<div><code>lsof</code>&nbsp;<code>-i tcp@ohaha.ks.edu.tw:</code><code>ftp</code>&nbsp;<code>-r&nbsp;</code><code>//</code><code>不断查看目前</code><code>ftp</code><code>连接的情况(-r，</code><code>lsof</code><code>会永远不断的执行，直到收到中断信号,+r，</code><code>lsof</code><code>会一直执行，直到没有档案被显示,缺省是15s刷新)</code></div>
<div><code>lsof</code>&nbsp;<code>-i tcp@ohaha.ks.edu.tw:</code><code>ftp</code>&nbsp;<code>-n&nbsp;</code><code>//lsof</code>&nbsp;<code>-n 不将IP转换为</code><code>hostname</code><code>，缺省是不加上-n参数</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>可以使用lsof -i:端口号来查看当前有哪些程序占用了某个端口。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyrej28.html">poj1847 最短路</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pypx79.html">&lbrack;歪谈&rsqb;我们该怎么正确面对&amp;quot&semi;批评&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71g7kq.html">WordPress学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvw6lo9.html">ArcGIS Javascript查询数据库并添加到地图上</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eg14m9.html">&lbrack;IIS&rsqb;IIS扫盲&lpar;七&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq134558.html">Understanding mysql max&lowbar;connect&lowbar;errors</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlg13k9.html">&lbrack;解决方案&rsqb;在Sql Server 2008&sol;2005 数据库还原出现 3154错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wmxplq.html">reCAPTCHA 简单分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvop4yq.html">Web-Scale IT 我之见！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjojp79.html">Linq&sol;EF&sol;lambda Group by&sol;Order by 多个字段详细用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zznee9.html">Android应用-包装脚本批量方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1kwnzq.html">vc类型转换函数大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jg343q.html">『计算机视觉』物体检测之RefineDet系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvldlg8.html">Hyperledger Fabric密码模块系列之BCCSP（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwlp3v9.html">分布式RPC框架性能大比拼 dubbo、motan、rpcx、gRPC、thrift的性能比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m234p2q.html">【svn】服务器搭建和迁移</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppnewd9.html">Codeforces 950D  A Leapfrog in the Array &lpar;思维&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjwo2jq.html">ios中Pldatabase的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95332re8.html">APK防反编译技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/953jgje8.html">AIOps探索：基于VAE模型的周期性KPI异常检测方法&mdash;&mdash;VAE异常检测</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn14g6g8.html">I&period;MX6 Android 移除 Settings wifi功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd06njq.html">I&period;MX6 Android USB Touch eGTouchA&period;ini文件存放</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd44m38.html">Android开发优化宝典</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1rdx79.html">JavaScript基础大全篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x7n4m8.html">oracle 问题若干 提醒注意</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zw2659.html">一个简单的MDI示范程序（Delphi）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd0xkmq.html">andorid 进度条</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zw2149.html">转载-KMP算法前缀数组优雅实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd4pvk8.html">java开发 时间类型的转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y35keq.html">LeetCode题解&mdash;&mdash;Two Sum</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
